local bindClass = luajava.bindClass
local bindClass2 = function(value) return bindClass("com.compiler.ad.bytedance.util."..value)end
local TTAdSdk = bindClass("com.bytedance.sdk.openadsdk.TTAdSdk")
local TTAdNative = bindClass("com.bytedance.sdk.openadsdk.TTAdNative")
local TTNativeAd = bindClass("com.bytedance.sdk.openadsdk.TTNativeAd")
local UIUtils = bindClass2("UIUtils")
local pangolins_ids

--广告位id (不是代码位id)
pangolins_ids={
  --横幅广告位
  banner_unit_id="102509970",
  --开屏广告位
  splash_unit_id="102510426",
  --feed广告位
  feed_unit_id="102509497",
  --激励视频广告位
  reward_unit_id="102510427",
  --插全屏广告位
  interstitial_full_unit_id="102509969",
}

pcall(import,"public_pangolins_ids")

if private_pangolins_ids then
  pangolins_ids=private_pangolins_ids
elseif activity.getPackageName()=="con.ahailove.cn" then
  pangolins_ids={
    --横幅广告位
    banner_unit_id="102413305",
    --开屏广告位
    splash_unit_id="102413306",
    --feed广告位
    feed_unit_id="102412915",
    --激励视频广告位
    reward_unit_id="102403877",
    --插全屏广告位
    interstitial_full_unit_id="102411577",
  }
elseif activity.getPackageName()=="con.qingjianvip.cn" then
  pangolins_ids={
    --横幅广告位
    banner_unit_id="102509970",
    --开屏广告位
    splash_unit_id="102510426",
    --feed广告位
    feed_unit_id="102509497",
    --激励视频广告位
    reward_unit_id="102510427",
    --插全屏广告位
    interstitial_full_unit_id="102509969",
  }
elseif public_pangolins_ids then
  pangolins_ids=public_pangolins_ids
elseif custom_pangolins_ids then
  pangolins_ids=custom_pangolins_ids
end

pangolins_funlib={}

--导入
function import_pangolins_lib()
  import("com.bytedance.sdk.openadsdk.AdSlot")
end

--获取广告位id
function get_unit_id(key)
  if (pangolins_ids and key and pangolins_ids[key]) then
    return pangolins_ids[key]
  end
end

pangolins_funlib["create_ad_native"]=function()
  return TTAdSdk.getAdManager().createAdNative(this);
end

pangolins_funlib["ad_destroy"]=function(values)
  if values then
  if (values["container"]) then
    pcall(function() values["container"].removeAllViews();end)
  end
  if values["object"] then
    pcall(function() values["object"].destroy()end)
  end
end
end

--横幅广告--
--初始化横幅广告监听器/回调
pangolins_funlib["init_banner_ad_listener"]=function(values)
  local TTAdDislike=bindClass("com.bytedance.sdk.openadsdk.TTAdDislike")
  local TTNativeExpressAd=bindClass("com.bytedance.sdk.openadsdk.TTNativeExpressAd")

  local default_interation_listener = TTNativeExpressAd.ExpressAdInteractionListener({
    onAdClicked=function(view,i)
      pcall(values["onAdClicked"],view,i)
    end,
    onAdShow=function(view,i)
      pcall(values["onAdShow"],view,i)
    end,
    onRenderFail=function(view,s,i)
      pangolins_funlib.ad_destroy(values)
      pcall(values["onRenderFail"],view,s,i)
    end,
    onRenderSuccess=function(view,v,i)
      pcall(values["onRenderSuccess"],view,v,i)
    end
  });

  local default_dislike_callback = TTAdDislike.DislikeInteractionCallback({
    onShow=function()
      pcall(values["onShow"])
    end,
    onSelected=function(i,s,b)
      if b then
        pangolins_funlib.ad_destroy(values)
      end
      pcall(values["onSelected"],i,s,b)
    end,
    onCancel=function()
      pangolins_funlib.ad_destroy(values)
      pcall(values["onCancel"])
    end
  })

  --广告加载监听器
  local default_listener = TTAdNative.NativeExpressAdListener({
    onError=function(code, msg) 
      if (values["container"]) then
        values["container"].removeAllViews();
      end
      if (values["object"]) then
        values["object"].destroy();
      end
      pcall(values["onError"],code,msg)
    end,
    onNativeExpressAdLoad=function(list)
      if (list and (list.size() > 0)) then
        values["object"] = list.get(0);
        pangolins_funlib.show_banner_ad(values["object"],values["container"],default_interation_listener,default_dislike_callback)
      else 
        pangolins_funlib.ad_destroy(values)
      end
      pcall(values["onNativeExpressAdLoad"],list)
    end})
  return default_listener,default_interation_listener,default_dislike_callback
end

--显示横幅广告
pangolins_funlib["show_banner_ad"]=function(object,container,interation_listener,dislike_callback)
  if (object==nil or container==nil) then
    return
  end
  object.setExpressInteractionListener(interation_listener)
  object.setDislikeCallback(activity,dislike_callback)
  local view = object.getExpressAdView();
  container.removeAllViews();
  container.addView(view);
end

--加载横幅广告
pangolins_funlib["load_banner_ad"]=function(values)
  --导入
  import_pangolins_lib()
  --广告id
  local unit_id = ((values["unit_id_key"] and get_unit_id(values["unit_id_key"])) or values["unit_id"] or get_unit_id("banner_unit_id"))
  --Banner大小
  local sizes=values["sizes"]
  local banner_height=((sizes and sizes["height"]) or 500)
  local banner_width=((sizes and sizes["width"]) or 500)

  local adSlot = AdSlot.Builder()
  .setCodeId(unit_id)
  .setImageAcceptedSize(UIUtils.dp2px(this, banner_width), UIUtils.dp2px(this, banner_height))
  .build();

  local adNativeLoader=pangolins_funlib.create_ad_native()

  local init_values=values
  init_values["adNative"]=adNativeLoader

  local bannerListener=pangolins_funlib["init_banner_ad_listener"](init_values)
  adNativeLoader.loadBannerExpressAd(adSlot, bannerListener);
  return adNativeLoader
end

pangolins_funlib["banner_destroy"]=function(values)
  pangolins_funlib.ad_destroy(values)
end


--Feed 信息流广告--
--初始化信息流广告监听器/回调
--加载插屏广告
pangolins_funlib["show_feed_ad"]=function(object,container,render_listener,interation_listener)
  if (object==nil or container==nil) then
    return
  end
  local manager = object.getMediationManager(); 
  if (manager) then
    if (manager.isExpress()) then
      object.setExpressRenderListener(render_listener);
      object.render();
    else
      local FeedAdUtils = bindClass2("FeedAdUtils")
      local feedView = FeedAdUtils.getFeedAdFromFeedInfo(object, this, nil, interation_listener);
      if (feedView) then
        UIUtils.removeFromParent(feedView);
        container.removeAllViews();
        container.addView(feedView);
      end
    end
  end
end
pangolins_funlib["init_feed_ad_listener"]=function(values)
  local MediationExpressRenderListener=bindClass("com.bytedance.sdk.openadsdk.mediation.ad.MediationExpressRenderListener")
  --广告模板展示监听器
  local default_express_render_listener = MediationExpressRenderListener({
    onAdClick=function(view,i)
      pcall(values["onAdClick"],view,i)
    end,
    onAdShow=function(view,i)
      pcall(values["onAdShow"],view,i)
    end,
    onRenderFail=function(view,s,i)
      pangolins_funlib.ad_destroy(values)
      pcall(values["onRenderFail"],view,s,i)
    end,
    onRenderSuccess=function(view,v1,v2)
      if (values["object"]) then
        local expressFeedView = values["object"].getAdView();
        UIUtils.removeFromParent(expressFeedView);
        values["container"].removeAllViews();
        values["container"].addView(expressFeedView);
      end
      pcall(values["onRenderSuccess"],view,v1,v2,b)
    end
  });

  --自渲染广告展示监听器
  local default_interation_listener = TTNativeAd.AdInteractionListener({
    onAdClicked=function(view,ttNativeAd)
      pcall(values["onAdClicked"],view,ttNativeAd)

    end,

    onAdCreativeClick=function(view,ttNativeAd)
      pcall(values["onAdCreativeClick"],view,ttNativeAd)
    end,
    onAdShow=function(ttNativeAd)
      pcall(values["onAdShow"],ttNativeAd)
    end
  })


  --广告加载监听器
  local default_listener = TTAdNative.FeedAdListener({
    onError=function(code, msg) 
      pangolins_funlib.ad_destroy(values)

      pcall(values["onError"],code,msg)
    end,
    onFeedAdLoad=function(list)
      if (list and (list.size() > 0)) then
        values["object"] = list.get(0);
        pangolins_funlib["show_feed_ad"](values["object"],values["container"],default_express_render_listener,default_interation_listener)
      else 
        pangolins_funlib.ad_destroy(values)
      end
      pcall(values["onFeedAdLoad"],list)
    end
  })

  return default_listener
end

--加载插屏广告
pangolins_funlib["load_feed_ad"]=function(values)
  --导入
  import_pangolins_lib()
  --广告id
  local unit_id = ((values["unit_id_key"] and get_unit_id(values["unit_id_key"])) or values["unit_id"] or get_unit_id("feed_unit_id"))
  --Feed大小
  local sizes=values["sizes"]
  local feed_height=((sizes and sizes["height"]) or 500)
  local feed_width=(((sizes and sizes["width"]~=nil) and UIUtils.dp2px(this,sizes["width"])) or UIUtils.getScreenWidthInPx(this))

  local ad_count=(values["ad_count"] or 1)--请求广告数量为1到3条 （优先采用平台配置的数量）
  local adSlot = AdSlot.Builder()
  .setCodeId(unit_id)
  .setImageAcceptedSize(feed_width, UIUtils.dp2px(this, feed_height))
  .setAdCount(ad_count)
  .build();

  local adNativeLoader=pangolins_funlib.create_ad_native()

  local init_values=values
  init_values["adNative"]=adNativeLoader

  local feedAdListener=pangolins_funlib["init_feed_ad_listener"](init_values)
  adNativeLoader.loadFeedAd(adSlot, feedAdListener);
  return adNativeLoader
end

--销毁 Feed
pangolins_funlib["feed_destroy"]=function(values)
  pangolins_funlib.ad_destroy(values)
end

--插屏广告--
--初始化插全屏广告监听器
pangolins_funlib["init_interstitial_full_ad_listener"]=function(values)
  local TTFullScreenVideoAd=bindClass("com.bytedance.sdk.openadsdk.TTFullScreenVideoAd")
  local default_interation_listener=TTFullScreenVideoAd.FullScreenVideoAdInteractionListener({
    onAdShow=function()
      pcall(values["onAdShow"])
    end,
    onAdVideoBarClick=function()
      pcall(values["onAdVideoBarClick"])
    end,
    onAdClose=function()
      pcall(values["onAdClose"])
    end,
    onVideoComplete=function()
      pcall(values["onVideoComplete"])
    end,
    onSkippedVideo=function()
      pcall(values["onSkippedVideo"])
    end
  })
  local default_callback = TTAdNative.FullScreenVideoAdListener({
    onError=function(code,msg)
      pcall(values["onError"],code,msg)
    end,
    onFullScreenVideoAdLoad=function(ad)
      values["object"]=ad
      pangolins_funlib["show_interstitial_full_ad"](values["object"],default_interation_listener)
      pcall(values["onFullScreenVideoAdLoad"],ad)
    end,
    onFullScreenVideoCached=function()
      pcall(values["onFullScreenVideoCached"])
    end,
    onFullScreenVideoCached=function(ad)
      values["object"]=ad
      pcall(values["onFullScreenVideoCached"],ad)
    end
  })
  return default_callback,default_interation_listener
end
--显示插屏广告
pangolins_funlib["show_interstitial_full_ad"]=function(object,interation_listener)
  if (object==nil or interation_listener==nil) then
    return
  end
  object.setFullScreenVideoAdInteractionListener(interation_listener);
  object.showFullScreenVideoAd(activity);
end
--加载插屏广告
pangolins_funlib["load_interstitial_full_ad"]=function(values)
  import_pangolins_lib()
  local TTAdConstant=bindClass("com.bytedance.sdk.openadsdk.TTAdConstant")
  local unit_id = ((values["unit_id_key"] and get_unit_id(values["unit_id_key"])) or values["unit_id"] or get_unit_id("interstitial_full_unit_id"))
  local adslot = AdSlot.Builder()
  .setCodeId(unit_id)
  .setOrientation(TTAdConstant.ORIENTATION_VERTICAL)
  .build();

  local adNativeLoader=pangolins_funlib.create_ad_native()
  local init_values=values
  init_values["object"]=interstitialFullAd
  local fullScreenVideoListener=pangolins_funlib["init_interstitial_full_ad_listener"](init_values)
  adNativeLoader.loadFullScreenVideoAd(adslot, fullScreenVideoListener);
  return adNativeLoader
end

pangolins_funlib["interstitial_full_ad_destroy"]=function(values)
  if (values and values["object"] and values["object"].getMediationManager()) then
    values["object"].getMediationManager().destroy();
  end
end

--激励视频--
--初始化激励视频广告监听器
pangolins_funlib["show_reward_ad"]=function(object,interation_listener)
  if (object==nil) then
    return
  end
  object.setRewardAdInteractionListener(interation_listener);
  object.showRewardVideoAd(this);
end

--初始化激励视频监听器
pangolins_funlib["init_reward_ad_listener"]=function(values)
  --广告展示监听器
  local TTRewardVideoAd=bindClass("com.bytedance.sdk.openadsdk.TTRewardVideoAd")
  local default_interation_listener=TTRewardVideoAd.RewardAdInteractionListener({
    onAdShow=function()
      pcall(values["onAdShow"])
    end,
    onAdVideoBarClick=function()
      pcall(values["onAdVideoBarClick"])
    end,
    onAdClose=function()
      pcall(values["onAdClose"])
    end,
    onVideoComplete=function()
      pcall(values["onVideoComplete"])
    end,
    onVideoError=function()
      pcall(values["onVideoError"])
    end,
    onRewardVerify=function()
      pcall(values["onRewardVerify"])
    end,
    onRewardArrived=function()
      pcall(values["onRewardArrived"])
    end,
    onSkippedVideo=function()
      pcall(values["onSkippedVideo"])
    end,
  })

  local default_callback=TTAdNative.RewardVideoAdListener({
    onError=function(i,s)
      pcall(values["onError"],i,s)
    end,
    onRewardVideoAdLoad=function(ttRewardVideoAd)
      values["object"] = ttRewardVideoAd;
      pcall(values["onRewardVideoAdLoad"])
    end,
    onRewardVideoCached=function()
      pcall(values["onRewardVideoCached"])
    end,
    onRewardVideoCached=function(ttRewardVideoAd)
      values["object"] = ttRewardVideoAd;
      pangolins_funlib["show_reward_ad"](values["object"],default_interation_listener)
    end
  })
  return default_callback,default_interation_listener
end

--加载激励广告
pangolins_funlib["load_reward_ad"]=function(values)
  --导入
  import_pangolins_lib()
  local TTAdConstant=bindClass("com.bytedance.sdk.openadsdk.TTAdConstant")
  local unit_id = ((values["unit_id_key"] and get_unit_id(values["unit_id_key"])) or values["unit_id"] or get_unit_id("reward_unit_id"))

  local adSlot = AdSlot.Builder()
  .setCodeId(unit_id)
  .setOrientation(TTAdConstant.ORIENTATION_VERTICAL)
  .build();

  local adNativeLoader=pangolins_funlib.create_ad_native()

  local init_values=values
  init_values["adNative"]=adNativeLoader

  local rewardListener=pangolins_funlib["init_reward_ad_listener"](init_values)
  adNativeLoader.loadRewardVideoAd(adSlot, rewardListener);

  return adNativeLoader
end

--销毁激励视频
pangolins_funlib["reward_destroy"]=function(values)
  if (values and values["object"] and values["object"].getMediationManager()) then
    values["object"].getMediationManager().destroy();
  end
end